/**
 * Copyright (C) 2007-2013 Lawrence Murray
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your option)
 * any later version.
 * 
 * @author Lawrence Murray <lawrence@indii.org>
 * $Rev$
 * $Date$
 */
#include "IllumObserver.hpp"

using namespace indii;

IllumObserver::IllumObserver() : watching(false) {
  //
}

IllumObserver::~IllumObserver() {
  ignore();
}

void IllumObserver::watch(IllumObservable* o) {
  ignore();
  o->subscribe(this);

  this->o = o;
  this->watching = true;
}

void IllumObserver::ignore() {
  if (watching) {
    o->unsubscribe(this);
  }

  this->watching = false;
}
